var LOGFILE_NAME = "remote-connectivity.log";
var lInfo = new Logger(LOGFILE_NAME);
var lWarn = new Logger(LOGFILE_NAME);
lInfo.logln("event raised = " + raisedEvent.name);

if (raisedEvent.name === 'remote-connectivity-disabled') {
    lInfo.logln("remote connectivity disabled event");
    if (raisedEvent.parameter && raisedEvent.parameter.success) {
        lInfo.logln("-- success code " + raisedEvent.parameter.success);
        if (raisedEvent.parameter.success == 'true') {
            (new Event("remote-connectivity.answer",{actions:'DeactivateRemoteConnectivity',result:true})).raise();
        } else {
            (new Event("remote-connectivity.answer",{actions:'DeactivateRemoteConnectivity',result:false, error:-1})).raise();
        }
        //now it is ok to uninstall this addon
        Property.setProperty('system/preventUninstall',false);
        Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
        Property.store();           
    } else {
        (new Event("remote-connectivity.answer",{actions:'DeactivateRemoteConnectivity',result:false, error:-1})).raise();
    }    
}

if (raisedEvent.name === 'remote-connectivity') {    
    if (raisedEvent.parameter.success!=null) {
        if (raisedEvent.parameter.success == 'true') {
            lInfo.logln('token ' + raisedEvent.parameter.osptoken);
        	if (raisedEvent.parameter.osptoken!=null) {
        		if (raisedEvent.parameter.relaylink!=null){
        			Property.load();
        			lInfo.logln('save token');
        		    Property.setProperty('OSPToken', raisedEvent.parameter.osptoken);
        		    Property.setFlag('OSPToken', 'ARCHIVE', true);
        		    //as long as remote connectivity is enabled this addon may not be uninstalled
        		    Property.setProperty('system/preventUninstall',true);
        	        Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
        		    Property.store();			
        		    (new Event("remote-connectivity.answer",{actions:'ActivateRemoteConnectivity',result:true})).raise();
        		}
        	}
        } else { 
            (new Event("remote-connectivity.answer",{actions:'ActivateRemoteConnectivity',result:false})).raise();
        } 
    }
    
    if (raisedEvent.parameter.actions!=null) {
    	Property.load();
    	switch (raisedEvent.parameter.actions) {
    		case 'monitorConnection' : {
    			Property.load();
    		    Property.setProperty('monitorPing', new Date().getTime());
    		    Property.setFlag('monitorPing', 'ARCHIVE', true);
    		    Property.setProperty('monitorHRPing', "" + new Date());
    		    Property.setFlag('monitorHRPing', 'ARCHIVE', true);
    		    Property.store();			
    		}
    		break;
    		case 'CheckUserByMAC': {
    			var result=(RemoteConnectivity.CheckUserByMAC());
    			if (result!=null) {
    				if (result.Response!=null) {
    					if (result.Response.ReturnCode==1) {
    						(new Event("remote-connectivity.answer",{actions:'CheckUserByMAC',result:false})).raise();
    					} else {
    						(new Event("remote-connectivity.answer",{actions:'CheckUserByMAC',result:true})).raise();
    						// make a apartmentmodel change
    						var sName=Property.getProperty('/apartment/zones/zone0/name');
    						Property.setProperty('/apartment/zones/zone0/name', 'temporary');
    						Property.setProperty('/apartment/zones/zone0/name', sName);
    					}
    				} else {
    					(new Event("remote-connectivity.answer",{actions:'CheckUserByMAC',result:false})).raise();
    				}
    			} else {
    				(new Event("remote-connectivity.answer",{actions:'CheckUserByMAC',result:false})).raise();
    			}
    			break;
    		}
    		break;
    		case 'RequestApplicationToken': {
    			lInfo.logln('RequestApplicationToken');
    			if (raisedEvent.parameter.appName!=null) {
    				if (raisedEvent.parameter.osptoken!=null) {
    					if (Property.getNode('OSPToken')!=null) {
    						if (Property.getNode('OSPToken').getValue()==raisedEvent.parameter.osptoken){
    							lInfo.logln('start generateToken');
    							var oToken=RemoteConnectivity.generateToken(raisedEvent.parameter.appName);
    							lInfo.logln('ok ' + oToken);
    							(new Event("remote-connectivity.answer",{actions:'RequestApplicationToken',token:oToken,resultcode:0})).raise();
    						} else {
    							lInfo.logln('wrong osp-token');
    							(new Event("remote-connectivity.answer",{actions:'RequestApplicationToken',resultcode:-4,error:'wrong OSP Token'})).raise();
    						}
    					} else {
    						lInfo.logln('no Connectivity in dSS enabled');
    						(new Event("remote-connectivity.answer",{actions:'RequestApplicationToken',resultcode:-1,error:'no Connectivity in dSS enabled'})).raise();
    					}
    				} else {
    					lInfo.logln('no OSP-Token delivered');
    					(new Event("remote-connectivity.answer",{actions:'RequestApplicationToken',resultcode:-2,error:'no OSP-Token delivered'})).raise();					
    				}
    			} else {
    				lInfo.logln('no App-Name delivered');
    				(new Event("remote-connectivity.answer",{actions:'RequestApplicationToken',resultcode:-3,error:'no App-Name delivered'})).raise();									
    			}
    		}
    		break;
    		case 'EnableToken': {
    			lInfo.logln('EnableToken');
    			if (raisedEvent.parameter.token!=null) {
    				if (Property.getNode('/system/security/applicationTokens/pending/'+raisedEvent.parameter.token)!=null) {
    					if (raisedEvent.parameter.osptoken!=null) {
    						if (Property.getNode('OSPToken')!=null) {
    							if (Property.getNode('OSPToken').getValue()==raisedEvent.parameter.osptoken){
    								lInfo.logln('start enableToken');
    								RemoteConnectivity.enableToken(raisedEvent.parameter.token);
    								lInfo.logln('ok ' + oToken);
    								(new Event("remote-connectivity.answer",{actions:'EnableToken',token:raisedEvent.parameter.token,resultcode:0})).raise();
    							} else {
    								lInfo.logln('wrong osp-token');
    								(new Event("remote-connectivity.answer",{actions:'EnableToken',resultcode:-4,error:'wrong OSP Token'})).raise();
    							}
    						} else {
    							lInfo.logln('no Connectivity in dSS enabled');
    							(new Event("remote-connectivity.answer",{actions:'EnableToken',resultcode:-1,error:'no Connectivity in dSS enabled'})).raise();
    						}
    					} else {
    						lInfo.logln('no OSP-Token delivered');
    						(new Event("remote-connectivity.answer",{actions:'EnableToken',resultcode:-2,error:'no OSP-Token delivered'})).raise();					
    					}
    				} else {
    					lInfo.logln('token not present');
    					(new Event("remote-connectivity.answer",{actions:'EnableToken',resultcode:-4,error:'token to enable not present'})).raise();									
    				}
    			} else {
    				lInfo.logln('no App-Name delivered');
    				(new Event("remote-connectivity.answer",{actions:'EnableToken',resultcode:-3,error:'no token delivered'})).raise();									
    			}
    		}
    		break;
    		case 'checkStatusRelaylink': {
    			lInfo.logln('checkStatusRelaylink');		
    			if (LocalConnectivity.getStatusRemoteAccess()) {
    				lInfo.logln('checkStatusRelaylink enabled');		
    				(new Event("remote-connectivity.answer",{actions:'checkStatusRelaylink',result:true})).raise();
    			} else {
    				lInfo.logln('checkStatusRelaylink disabled');		
    				(new Event("remote-connectivity.answer",{actions:'checkStatusRelaylink',result:false})).raise();
    			}
    		}
    		break;
    		case 'enableRelaylink': {
    			lInfo.logln('enableRelaylink');
    			LocalConnectivity.enableRelaylink();
    			(new Event("remote-connectivity.answer",{actions:'enableRelaylink',result:true})).raise();
    		}
    		break;
    		case 'disableRelaylink': {
    			lInfo.logln('disableRelaylink');
    			LocalConnectivity.disableRelaylink();
    			(new Event("remote-connectivity.answer",{actions:'disableRelaylink',result:true})).raise();
    		}
    		break;
    		case 'checkStatusBackup': {
    			lInfo.logln('checkStatusBackup');		
    			if (LocalConnectivity.getStatusBackup()) {
    				lInfo.logln('checkStatusBackup enabled');		
    				(new Event("remote-connectivity.answer",{actions:'checkStatusBackup',result:true})).raise();
    			} else {
    				lInfo.logln('checkStatusBackup disabled');		
    				(new Event("remote-connectivity.answer",{actions:'checkStatusBackup',result:false})).raise();
    			}
    		}
    		break;
    		case 'saveUserName' : {
    		    Property.load();
    		    var userName = unescape(raisedEvent.parameter.userName);
                lInfo.logln('save user name "' + userName + '" for later use');
                Property.setProperty('username', userName);
                Property.setFlag('username', 'ARCHIVE', true);
                Property.store();           
    		}
    		break;
    		case 'cleanUpPropertyTree' : {
    		    Property.load();
    		    if (Property.getNode('Relaylink')!=null) {
    		        Property.getNode('/scripts/remote-connectivity').removeChild('Relaylink');
    		    }
    		    Property.store();
    		}
    		break;
    		default: {
    		    
    		}
    	}
    }
}


