/**
 * Show an simple error dialog
 * 
 * 
 */
function createErrorDialog() {
    var errorDialog;
    var ok = Ext.create('Ext.button.Button', {
        text : sOK,
        width : 50,
        handler : function() {
            errorDialog.close();
        }
    });
   var buttonPanel = Ext.create('Ext.container.Container', {
       items : [ok],
       padding : '5 5 5 5', //top right bottom left
       layout : {
           type : 'hbox',
           pack : 'center',
           align : 'middle'
       },
   });

   var dialogPanel = Ext.create('Ext.form.field.Display', {
       padding: '5 40 5 5', //top right bottom left
       border : 0,
       height : 50,
       hideLabel : true,
       value : sErrorDefaultText,      
   });

   errorDialog = Ext.create('Ext.window.Window',{
       modal : true, 
       layout : {
           type : 'vbox',
           align : 'center',
       },
       padding: '10 10 10 10', //top right bottom left
       header:false,
       closable:false,
       items: [dialogPanel, buttonPanel], 
       showWindow : function(sErrorText) {
           if ((sErrorText != undefined) && (sErrorText != '')) {
               dialogPanel.setValue(sErrorText);
           }
           this.show();
       },
   });
   return errorDialog;
};

/**
 * Creates the login dialog to enter user name and password.
 * 
 * @returns {object} the created dialog object
 */
function createLoginDialog() {
    var me = this;
    var loginDialog;
    var userName = Ext.create('Ext.form.field.Text', {
        name : 'edit_userName',
        id : 'edit_userName',
        fieldLabel : sUserNameLabel,
        allowBlank : false,
        blankText : sBlankTextUser,
        invalidText : sBlankTextUser,
        style: {color:'#005138'},
        width: 400,
        labelWidth: 100,
        padding:'10 5 5 5', //top right bottom left
    });
    var password = Ext.create('Ext.form.field.Text', {
        name : 'edit_pwd',
        id : 'edit_pwd',
        fieldLabel : sPasswordLabel,
        allowBlank : false,
        blankText : sBlankTextPwd,
        invalidText : sBlankTextPwd,
        style: {color:'#005138'},
        width:400,
        labelWidth:100,
        padding: '10 5 5 5 ', //top right bottom left
        inputType: 'password',
    });
      
  var ok = Ext.create('Ext.button.Button', {
      text : sOK,
      width : 50,
      margins:'0 5 0 0', //top right bottom left
      handler : function() {
          RemoteConnectivity.userAccount = RemoteConnectivity.LoginDialog.items.getByKey('edit_userName').getValue();
          RemoteConnectivity.userPwd = RemoteConnectivity.LoginDialog.items.getByKey('edit_pwd').getValue();

          //enabling remote connectivity: send request to dSS
          dss.ajaxAssyncRequestWithoutAnswer('/cgi-bin/authservicewrapper.sh',{username:RemoteConnectivity.userAccount,password:RemoteConnectivity.userPwd,datasharing:2});
          //hide the login window and show a wait dailog instead
          RemoteConnectivity.LoginDialog.hide();
          //show wait window
          RemoteConnectivity.waitWindow.showWindow(sWaitConnecting, true);
          RemoteConnectivity.waitAndReload('ActivateRemoteConnectivity');               
      }
  });
  var cancel = Ext.create('Ext.button.Button', {
      text : sCancel,
      width : 50,
      margins:'0 0 0 5', //top right bottom left
      handler : function() {
          RemoteConnectivity.LoginDialog.hide();
      }
  });
  var buttonPanel = Ext.create('Ext.container.Container', {
      items : [ok, cancel],
      padding : '5 5 5 5', //top right bottom left
      layout : {
          type : 'hbox',
          pack : 'center',
          align : 'middle'
      },
   });
  
    loginDialog = Ext.create('Ext.window.Window', {
        modal : true, 
        //width : 500,
        layout : {
            type : 'vbox',
            align : 'stretch',
        },
        padding: '10 10 10 10', //top right bottom left
        header:true,
        title: sLoginTitle,
        closable:false,
        resizable: false,
        items:[userName,  password, buttonPanel]
    });

    return loginDialog;
};

/**
 * Create a wait window with progress bar
 * 
 * @return {object} the created WaitDialog object
 */
function createWaitWindow() {
    var waitDialog;
    var progressBar = Ext.create('Ext.ProgressBar', {
        width: 300,
        margin : '0 10 10 10', //top right bottom left
     });

    var ok = Ext.create('Ext.button.Button', {
        text : sOK,
        width : 50,
        handler : function() {
            waitDialog.closeWindow();
        },
    });

    var buttonPanel = Ext.create('Ext.container.Container', {
       items : [ok],
       padding : '5 5 5 5',
       layout : {
           type : 'hbox',
           pack : 'center',
           align : 'middle'
       },
   });

   var dialogPanel = Ext.create('Ext.form.field.Display', {
       padding: '5 40 5 5', //top right bottom left
       border : 0,
       width : 500,
       height : 50,
       hideLabel : true,
       value : sDefaultWaitText,      
   });

   waitDialog = Ext.create('Ext.window.Window',{
       modal : true, 
       layout : {
           type : 'vbox',
           align : 'center',
       },
       padding: '10 10 10 10', //top right bottom left
       header:false,
       closable:false,
       resizable: false,
       items: [dialogPanel, progressBar /*, buttonPanel*/],
       showWindow : function(sDialogText, bShowProgress) {
           if ((sDialogText != undefined) && (sDialogText != '')) {
               dialogPanel.setValue(sDialogText);
           }
           progressBar.setVisible(bShowProgress);
           progressBar.reset();
           progressBar.wait();
           this.show();
       },
       closeWindow : function() {
           progressBar.reset();
           this.hide();
       }
   });

    return waitDialog;
};

/**
 * Create a wait window with progress bar
 * 
 * @return {object} the created WaitDialog object
 */
function createConfirmationDialog() {
    var confirmationDialog;

    var ok = Ext.create('Ext.button.Button', {
        text : sOK,
        //width : 50,
        margins : '0 5 0 0', //top right bottom left
        handler : function() {
            confirmationDialog.closeDialog();
            RemoteConnectivity.disconnectService();
        },
    });

    var cancel = Ext.create('Ext.button.Button', {
        text : sCancel,
        margins : '0 0 0 5', //top right bottom left
        //width : 50,
        handler : function() {
            confirmationDialog.closeDialog();
        },
    });

    var buttonPanel = Ext.create('Ext.container.Container', {
       items : [ok, cancel],
       padding : '5 5 5 5',
       layout : {
           type : 'hbox',
           pack : 'center',
           align : 'middle'
       },
   });

   var dialogPanel = Ext.create('Ext.form.field.Display', {
       padding: '5 40 5 5', //top right bottom left
       border : 0,
       height : 50,
       hideLabel : true,
       value : sDefaultConfirmation,      
   });

   confirmationDialog = Ext.create('Ext.window.Window',{
       modal : true, 
       layout : {
           type : 'vbox',
           align : 'center',
       },
       padding: '10 10 10 10', //top right bottom left
       header:false,
       closable:false,
       resizable: false,
       items: [dialogPanel, buttonPanel],
       showDialog : function(sDialogText, sButtonText) {
           if ((sDialogText != undefined) && (sDialogText != '')) {
               dialogPanel.setValue(sDialogText);
           }
           ok.setText(sButtonText);
           this.show();
       },
       closeDialog : function() {
           this.hide();
       },
   });
    return confirmationDialog;
};